**microStudio** - это интегрированная среда разработки видеоигр.
Она включает в себя все инструменты, необходимые для создания вашей первой видеоигры!
**microStudio** предлагает все следующие возможности:

* редактор спрайтов (изображений, в пиксель-арте)
* редактор карт (т.е. карт или уровней)
* редактор кода для программирования на microScript, простом, но мощном языке
* 100% онлайновая работа, позволяющая мгновенно протестировать вашу игру в любое время в процессе ее разработки
* возможность легко установить готовую или в процессе разработки игру на смартфоны и планшеты
* возможность работать с несколькими людьми над одним проектом с мгновенной синхронизацией
* функции обмена опытом в сообществе, которые позволяют вам изучать чужие проекты, учиться и повторно использовать все, что вы хотите, для своего собственного проекта

# Быстрый старт

Вы можете начать с изучения проектов, созданных другими пользователями, в разделе *Обзор*.

Вы можете начать творить как гость или сразу создать учетную запись. Выберите псевдоним (избегайте использования
свое настоящее имя), введите адрес электронной почты (это необходимо на случай, если вы забудете пароль) и поехали!

## Первый проект

Вы можете либо создать новый пустой проект в разделе Создать, либо выбрать существующий проект в разделе Обзор и нажать на кнопку "Клонировать", чтобы создать свою копию и начать ее настраивать.

### Код

После создания проекта вы попадаете в раздел "Код". Здесь вы можете начать программировать. Попробуйте скопировать и вставить приведенный ниже код:

```
draw = function()
  screen.drawSprite ("icon", 0, 0, 100, 100)
end
```

### Выполнить

Затем нажмите на кнопку Запустить в правой части экрана. Ваша программа запускается, и вы видите, что приведенный выше код отображает значок проекта в центре экрана. Измените координаты отображения (цифры 0 и 100), чтобы увидеть, как меняется положение и размеры значка.

### Модификация в реальном времени

Затем вы можете сделать эту первую программу более интерактивной, скопировав и вставив код ниже:

```
update = function()
  if keyboard.LEFT then x -= 1 end
  if keyboard.RIGHT then x += 1 end
  if keyboard.UP then y += 1 end
  if keyboard.DOWN then y -= 1 end
end

draw = function()
  screen.fillRect(0, 0, 400, 400, "#000")
  screen.drawSprite("icon", x, y, 20, 20)
end
```

Теперь программа позволяет перемещать иконку проекта с помощью стрелок клавиатуры. Смысл функций ``update`` и ``draw``, тестирование клавиш клавиатуры с помощью ``keyboard``, рисование на экране с помощью ```screen``` подробно описаны далее в этой документации.

Вы также можете перейти в раздел Спрайты, щелкнуть на элементе "icon" и начать редактировать изображение. Когда вы вернетесь в раздел Код, вы увидите, что ваши изменения мгновенно применяются в запущенной программе.

# Обзор

Основной раздел *Обзор* позволяет вам обнаружить проекты, созданные другими пользователями. Вы можете найти примеры игр, многоразовые шаблоны, библиотеки спрайтов в различных стилях и тематиках. Если вас заинтересовал какой-то проект, вы можете его клонировать, то есть создать его полную копию, которую затем можно изменить и использовать в своих целях.

Если вы уже открывали один из своих проектов в разделе "Создать", вы сможете импортировать каждый спрайт или исходный файл проектов, которые вы изучаете, в свой текущий проект. Это позволит вам выбрать интересующие вас изображения или функции из публичных проектов сообщества и повторно использовать их в своих целях.

# Создать проект

Вы можете создать пустой проект в главном разделе *Создать*. Ваш проект состоит из нескольких разделов:

* **Код**: здесь вы создаете свои программы и начинаете выполнять свой проект для его тестирования и отладки.
* **Спрайты**: *спрайты* - это изображения, которые вы можете рисовать и изменять в этом разделе. Вы можете легко ссылаться на них, чтобы отобразить их (вставить на экран), когда создаете свою игру.
* **Карты**: карты - это сцены или уровни, которые вы можете создать, собрав спрайты на сетке. Вы можете легко отобразить их на экране в вашей программе.
* **Звуки**: здесь вы можете добавлять и редактировать звуки в вашем проекте.
* **Музыка**: здесь вы можете добавлять и редактировать музыку в вашем проекте.
* **Документ**: здесь вы можете написать документацию для своего проекта; это может быть документ по дизайну игры, учебник, руководство по повторному использованию вашего проекта в качестве шаблона и т.д.
* **Настройки**: здесь вы можете установить различные параметры для вашего проекта; вы также можете пригласить других пользователей участвовать в проекте вместе с вами.
* **Экспорт**: здесь вы можете сделать свой проект публичным; не забудьте создать описание и добавить теги.

## Код

В этом разделе вы программируете и тестируете свой проект. Для вашего проекта автоматически создается файл исходного кода. Вы можете добавить другие, чтобы разделить функциональные возможности вашего проекта на различные подразделы.

Работа программы microStudio основана на выполнении вами трех основных функций:

* функция ``init``, где вы инициализируете ваши переменные
* функция ``update``, где вы анимируете объекты и сканируете вводы
* функция ``draw``, где вы рисуете на экране

<!--- help_start init = function --->
### Функция ``init()``

Функция init вызывается только один раз при запуске программы. Она полезна, в частности, для определения начального состояния глобальных переменных, которые могут быть использованы в остальной части программы.
<!--- help_end --->
##### Пример
```
init = function()
  status = "Добро пожаловать"
  level = 1
  position_x = 0
  position_y = 0
end
```

### Функция ``update()``
<!--- help_start update = function --->.
Функция ``update`` вызывается 60 раз в секунду. Тело этой функции - лучшее место для программирования логики и физики игры: изменения состояния, движения спрайтов или врагов, обнаружения столкновений, клавиатуры, оценки сенсорных входов или входов геймпада и т.д.
<!--- help_end --->

##### Пример
```
update = function()
  if keyboard.UP then y = y+1 end
end
```

Приведенный выше код увеличивает значение переменной y на 1 каждые 60 секунд, если на клавиатуре нажата клавиша ``UP`` (стрелка вверх).

<!--- help_start draw = function --->
### Функция ``draw()``
Функция ``draw`` вызывается так часто, как только экран может быть обновлен. В ней вы должны нарисовать сцену на экране, например, заполнить большой цветной прямоугольник (чтобы стереть экран), а затем нарисовать несколько спрайтов или фигур поверх него.
<!--- help_end --->.

##### Пример
```
draw = function()
  // заполняем экран черным цветом
  screen.clear()
  // отрисовываем спрайт "icon" в центре экрана, размером 100x100
  screen.drawSprite("icon", 0, 0, 100, 100)
end
```

В большинстве случаев ``update`` происходит 60 раз в секунду. Но некоторые компьютеры или планшеты могут обновлять экран 120 раз в секунду или даже больше. Также может случиться, что устройство, на котором запущена программа, перегружено и не может обновлять экран 60 раз в секунду, в этом случае функция ``draw`` будет вызываться реже. Вот почему ``update`` и ``draw`` - это две отдельные функции: что бы ни случилось, ``update`` будет вызываться ровно 60 раз в секунду, а когда вызывается ``draw``, значит, пора перерисовывать экран.

### Выполнение

В разделе "Код" правая часть экрана позволяет увидеть вашу программу в действии, продолжая модифицировать ее исходный код. Чтобы запустить программу, просто нажмите на кнопку <i class="fa fa-play"></i>. Вы можете прервать выполнение программы в любое время, нажав на кнопку <i class="fa fa-pause"></i>.

### Консоль

Во время выполнения вашей программы вы можете использовать консоль для выполнения простых команд на *microScript*. Например, вы можете просто ввести имя переменной, чтобы узнать ее текущее значение.

##### Примеры
Узнать текущее значение переменной position_x
```
> position_x
34
>
```
Изменить значение position_x
```
> position_x = -10
-10
>
```
Вызовите функцию draw(), чтобы увидеть изменение position_x и его влияние на рисунок на экране (предполагая, что выполнение приостановлено)
```
> draw()
>
```

### Трассировка

В коде вашей программы вы можете в любой момент отправить текст для вывода на консоль, используя функцию ``print()``.

##### Пример
```
draw = function()
  // ваша реализация draw()

  print(position_x)
end
```

## Спрайты

Спрайты - это изображения, которые могут перемещаться по экрану. Инструмент рисования в *microStudio* позволяет создавать спрайты, которые затем можно использовать в программном коде для отображения их на экране в нужном положении и размере.

### Создание спрайта
В каждом проекте есть спрайт по умолчанию, называемый "icon", который будет выступать в качестве иконки приложения. Вы можете создавать новые спрайты, нажав на *Добавить спрайт*. Вы можете переименовать их по своему усмотрению и задать их размер в пикселях (ширина х высота).

### Параметры рисования
*microStudio* предлагает классические функции рисования: карандаш, заливка, ластик, осветление, затемнение, смягчение, увеличение контраста, изменение насыщенности.

Инструмент "Пипетка" можно использовать в любое время, нажав клавишу [Alt] на клавиатуре.

Опции *плитка* и симметрия помогут вам создать "повторяющиеся" спрайты или спрайты с одной или двумя осями симметрии.

##### Совет
Вы можете импортировать файлы изображений в проект microStudio. Для этого перетащите файлы PNG или JPG (размером до 256x256 пикселей) в список спрайтов.

## Карты
Карта в microStudio - это сетка для сборки спрайтов. С ее помощью можно собрать декорацию или создать уровень.

### Создать карту
Карты можно создавать и переименовывать так же, как и спрайты. Можно изменять размер сетки (в количестве ячеек). Каждая ячейка может быть нарисована спрайтом. Можно изменить размер в пикселях каждой ячейки, что в целом должно отражать размер спрайтов, используемых для рисования сетки.


## Настройки
Вкладка *Настройки* позволяет вам настроить некоторые элементы вашего проекта.

### Опции
Вы можете задать название проекта, его идентификатор (используемый для создания его URL, т.е. интернет-адреса).

Вы можете указать, в каком режиме должен использоваться ваш проект - портретном или альбомном. Этот выбор будет учитываться при установке вашего приложения на смартфон или планшет.

Вы также можете указать желаемые пропорции для области отображения на экране. Эта опция нужна для того, чтобы приложение всегда выглядело хорошо при установке на устройства с экранами разных пропорций.

### Пользователи

Раздел "Пользователи" позволяет вам пригласить друзей для участия в вашем проекте. Вы должны знать никнейм друга, которого хотите пригласить. После приглашения друга, если он примет ваше приглашение, он получит полный доступ к вашему проекту и сможет вносить любые изменения по своему желанию (изменять, добавлять, удалять спрайты, карты, код и т.д.). Однако изменение параметров проекта и списка участников остается за владельцем проекта.

## Публикация

*microStudio* предлагает несколько вариантов публикации или экспорта вашего проекта. Вы можете экспортировать свой проект как отдельное HTML5-приложение для распространения в Интернете, на своем сайте или на платформах распространения игр. Вы также можете сделать свой проект публичным на *microStudio*, чтобы сообщество могло играть с ним, комментировать, изучать исходный код и активы... В будущем планируется расширить возможности экспорта.

### Сделать проект публичным

Чтобы сделать ваш проект доступным для всех (только для чтения), нажмите на "Сделать мой проект публичным". Когда ваш проект станет общедоступным, он будет отображаться на вкладке "Обзор" сайта microStudio. Любой посетитель сможет запустить игру, просмотреть и повторно использовать исходный код и другие компоненты вашего проекта.

Ваша игра имеет постоянный URL в виде ``https://microstudio.io/author_nickname/game_id/``. Вы, конечно, можете распространять эту ссылку среди всех желающих или добавить свою игру на существующий сайт, встроив ее в iframe.

### Экспорт в HTML5

Чтобы экспортировать весь проект в отдельное приложение HTML5, нажмите " Экспортировать в HTML5". Это приведет к загрузке ZIP-архива, содержащего все файлы, необходимые для запуска вашей игры: спрайты, некоторые файлы JavaScript, иконки и основной HTML-файл "index.html". Ваша игра может быть запущена локально (двойной щелчок по файлу index.html) или вы можете загрузить ее на ваш существующий веб-сайт. Она также готова к публикации на многих онлайновых дистрибутивах игр.
