# Tutorial

:project Programmazione

## Introduzione

:overlay

:posizione 30,30,40,40

:navigate projects.code.console

### Programmazione

In questo corso tutorial, impareremo a programmare in **microScript**.

Clicca sul pulsante "next" per continuare:

:navigate projects.code.console

:highlight #tutorial-window .navigation .next

## Console

:navigate projects.code.console

:position 60,30,40,50

### Console

Come introduzione alla programmazione, giocheremo con la console di microStudio.
La console permette di conversare con il computer digitando del testo (codice) e leggendo
le risposte del computer.

:highlight #terminal

## Ingresso console

:navigate projects.code.console

Per iniziare a programmare, clicca sull'area di input della console (evidenziata).

:highlight #terminal-input-line

:auto

## Scrivi una parola

:navigate projects.code.console

### Digita una parola

Digitare una parola con la tastiera, come:

```
ciao
```

Poi convalida il tuo input premendo il tasto [Return] o [⏎].

:auto #terminal-input

## Rispondi

:navigate projects.code.console

Se hai digitato ```ciao```, microScript ha risposto con ```0```.

Non arrabbiarti, il computer non voleva essere scortese! Un computer non è
così intelligente come pensi. Può lavorare duramente, ma ha bisogno che tu esprima
esattamente ciò che ti aspetti da lui.

Programmare significa dire al computer cosa fare, usando un linguaggio che può
capire.

## Risposta 2

:navigate projects.code.console

Il computer ha risposto con ```0``` perché non conosce ```ciao```. Ha
ha cercato nella sua memoria una *variabile* che si chiamasse così, ma non ha
trovato nulla.

Ha quindi risposto ```0``` che per lui significa anche niente, non trovato, sconosciuto.
Proviamo a insegnargli qualcosa, digitate:

```
ciao = 5
```

:auto #terminal-input

## Assegna un valore ad una variabile

:navigate projects.code.console

Convalidando questa linea, abbiamo appena *assegnato* il valore ```5``` alla *variabile* ```ciao```.
Il computer ha creato una cella nella sua memoria, etichettata "ciao" e nella quale ha memorizzato
il valore 5.

Ora possiamo chiederlo di nuovo:

```
ciao
```

La console risponde 5! Sembra che finalmente abbia imparato qualcosa.

## Fare calcoli

:navigate projects.code.console

Ma può anche contare? Proviamo:

```
1+1
```

Impressionante, vero? Ora:

```
ciao*2
```

OK ora questo è qualcosa, sembra che possa usare la sua memoria e fare calcoli
*simultaneamente*.
Possiamo certamente ricavarne qualcosa. È ora di passare al
prossimo tutorial per imparare di più sulle variabili.


