# Tutorial

:project Урок: Создание игры

## Введение

:position 30,30,40,40

:overlay

### Создание игры

В этой серии уроков мы создадим простую, но полностью рабочую игру менее чем за  70 строк кода.

В этой части предполагается, что вы уже прошли серию уроков по программированию.

При выполнении этого урока вы можете позволить вашей игре работать непрерывно, и вы увидите, как она улучшается  в реальном времени.

Вот пример того, как может выглядеть конечная игра:

https://microstudio.io/gilles/skaterun/

## Hero

:position 50,50,40,40

:highlight #menuitem-sprites

### Герой

Нашей игре нужен Герой. Перейдите на вкладку "Спрайты" и нажмите "Добавить спрайт".

Не забудьте переименовать ваш спрайт в "hero", это пригодится позже. Затем вы можете начать рисовать свой спрайт.
Вы можете потратить на своего героя столько времени, сколько захотите. Вы даже можете сделать его анимированным, открыв панель инструментов Анимация  в нижней части окна и добавить кадры анимации.


## Начальный код

:highlight #menuitem-code

### Начальный код

Теперь мы начнем кодирование для отображения нашего героя на экране. Щелкните, чтобы открыть вкладку Код.

На данный момент код нашей игры выглядит следующим образом:

```
init = function()
end

update = function()
end

draw = function()
end
```

``init``, ``update`` и ``draw`` - это три ключевые функции в microStudio, о которых необходимо знать.

``init`` вызывается только один раз, когда начинается ваша игра. Позже мы будем использовать ее для инициализации нескольких глобальных переменных.

``update`` вызывается ровно 60 раз в секунду во время работы игры. Мы также будем использовать его позже, чтобы обновить игру анимации, физики и логики.

``draw`` вызывается каждый раз, когда экран может быть перерисован. Мы начнем работать над телом этой функции.


## Рисование фона

### Рисование фона

Вставим строку в тело функции draw:

```
draw = function()
  screen.clear("rgb(57, 0, 57)")
end
```

## Запуск

:highlight #run-button

### Запуск программы

Нажмите на кнопку запуска, чтобы запустить вашу программу.

Строка, которую мы добавили, полностью заполняет экран указанным цветом. Щелкните на нем и удерживайте нажатой клавишу CTRL, чтобы выбрать другой цвет с помощью окна выбора цвета!

## Отображение нашего героя

### Отображение нашего героя

Добавьте следующую строку в тело функции draw после вызова ``screen.clear``:

```
  screen.drawSprite("hero", -80, -50, 20)
```

Эта строка рисует спрайт вашего героя на экране. Если ничего не отображается, проверьте, запущена ли программа и проверьте, правильно ли вы переименовали ваш спрайт в "hero".

Ваш полный код должен выглядеть следующим образом:

```
init = function()
end

update = function()
end

draw = function()
  screen.clear("rgb(57, 0, 57)")
  screen.drawSprite("hero",-80,-50,20)
end

update = function()
end

draw = function()
  screen.fillRect(0,0,screen.width,screen.height, "rgb(57,0,57)")
  screen.drawSprite("hero",-80,-50,20)
конец
```

## Конец

### Конец

Продолжим следующий урок, в котором мы создадим полог, по которому наш герой будет бежать.