# Tutorial

:project Урок: Создание игры

## Пол

:position 50,50,40,40

:highlight #menuitem-sprites

### Стена

Наш герой будет двигаться по полу, или платформе, или дороге... Назовем это стена. Мы создадим эту стену, имея в качестве спрайта плитку стены и заполнив ею всю область. Создайте новый спрайт и не забудьте переименовать его в "wall".

Было бы неплохо, если бы этот спрайт плитки выглядел хорошо после того, как на него будет наложена плитка.
Чтобы помочь вам в этом, мы рекомендуем активировать опцию "Плитка" в правом нижнем углу редактора спрайтов.
Пора рисовать!

## Отображение стены

:highlight #menuitem-code

### Отображение стены

Давайте вернемся к нашему коду. Убедитесь, что программа все еще запущена (при необходимости нажмите кнопку Запуск).
Добавим следующие строки в тело функции ``draw``:

```
  for i=-6 to 6 by 1
    screen.drawSprite("wall", i*40, -80, 40)
  end
```

Приведенный выше код представляет собой цикл ``for``. В нем обозначено, что функция ``screen.drawSprite`` будет вызываться несколько раз, каждый раз с переменной ``i``, имеющей другое значение. ``i`` будет начинаться с -6, затем -5, -4 ... , 3, 4, 5, 6. Таким образом координата x для рисования спрайта будет принимать значения -240, затем -200, -160 ... до 240. Вы можете увидеть результаты в окне выполнения.

## Отображение стены

### Отображение стены

Теперь полный код выглядит следующим образом. Наша следующая задача - анимировать стену, чтобы создать иллюзию, что герой бежит по ней.

```
init = function()
end

update = function()
end

draw = function()
  screen.clear("rgb(57, 0, 57)")

  for i=-6 to 6 by 1
    screen.drawSprite("wall", i*40, -80, 40)
  end

  screen.drawSprite("hero", -80, -50, 20)
end
```

## Анимация стены

### Анимация стены

Мы введем переменную ``position''. Мы будем использовать ее для перемещения плитки стены влево на некоторую величину. Давайте перепишем строку, рисующую плитки стены, следующим образом:

```
    screen.drawSprite("wall", i*40-position, -80, 40)
```

Стена пока не движется, потому что мы не меняем значение position. Давайте вставим эту строку в тело функции
функции ``update``:

```
update = function()
  position += 2
end
```

Делая это, мы гарантируем, что 60 раз в секунду (частота вызова функции update) значение position будет увеличивается на 2. Наша стена быстро сдвинулась и полностью исчезла слева. Упс!

## Анимация стены

## Анимация стены

Наши плитки стены расположены на расстоянии 40 единиц. Вместо того чтобы перемещать их влево на величину *position*, мы будем перемещать их влево на величину их влево на ``position % 40``. ``position % 40`` - это остаток от деления *position* на 40. При увеличении позиция будет принимать значения 0, 1, 2, 3 ..., 39, затем снова 0, 1, 2, 3 ..., 39 и так далее. Именно то, что нам нужно. Не убедительно? Давайте попробуем:

```
  for i=-6 to 6 by 1
    screen.drawSprite("wall", i*40-position%40, -80, 40)
  end
```

Видите? Все еще движется влево, не исчезая. Иллюзия идеальна!

## Конец

### Конец

В следующем коротком уроке мы заставим нашего героя прыгать. А пока вот копия нашего полного кода для справки:

```
init = function()
end

update = function()
  position += 2
end

draw = function()
  screen.clear("rgb(57, 0, 57)")

  for i=-6 to 6 by 1
    screen.drawSprite("wall", i*40-position%40, -80, 40)
  end

  screen.drawSprite("hero", -80, -50+hauteur, 20)
end
```